SystemOrganization addCategory: #'Amop-Core'!
SystemOrganization addCategory: #'Amop-Core-Tests'!
SystemOrganization addCategory: #'Amop-Compiler'!

Trait named: #TNoopTrap
	uses: {}
	category: 'Amop-Core'!

!TNoopTrap methodsFor: 'as yet unclassified' stamp: 'ewe 2/7/2013 16:34'!
baseObject
	^self ! !

!TNoopTrap methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 12:09'!
equals: anObject
Transcript show: 'other: '; show: anObject class asString; cr. 

	^ super = anObject baseObject ! !

!TNoopTrap methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 12:09'!
identityEquals: anObject
Transcript show: 'other: '; show: anObject class asString; cr. 

	^ super == anObject baseObject ! !

!TNoopTrap methodsFor: 'as yet unclassified' stamp: 'ewe 2/7/2013 17:16'!
literalTrap: argument
	Transcript show: 'Literal '; show: 'xxx'  ; cr. 	
	^ ValueProxy resolve: argument. ! !

!TNoopTrap methodsFor: 'as yet unclassified' stamp: 'ewe 1/22/2013 16:56'!
newTrap: argument
	^argument
	! !

!TNoopTrap methodsFor: 'as yet unclassified' stamp: 'ewe 1/28/2013 12:17'!
readField: field 
	Transcript show: 'Read '; show: field ; cr. 
	^self  instVarNamed: field 
	
	! !

!TNoopTrap methodsFor: 'as yet unclassified' stamp: 'ewe 2/7/2013 15:39'!
trap: block selector: selector arguments: arguments
	
	| sender receiver senderHandler receiverHandler target message targetWithArgs  |
	
	Transcript show: 'NoProxy@'; show: self class asString; show: '>>trap ';  show: selector ; cr. 
		
	"sender of this message is the old receiver"
	sender := ProxyHandler receiverProxy. 
	senderHandler := ProxyHandler receiverProxyHandler.
	"now swap the receiver"
	receiver := self.
	receiverHandler := #NoHandler.
	ProxyHandler receiverProxy:  receiver handler: receiverHandler.. 

	[	
		targetWithArgs := OrderedCollection new.
		targetWithArgs add: self . 
		targetWithArgs addAll: arguments. 
		^ block valueWithArguments: targetWithArgs .
	] ensure: [
		ProxyHandler receiverProxy:  sender handler: senderHandler.. 
	]
	! !

!TNoopTrap methodsFor: 'as yet unclassified' stamp: 'ewe 1/28/2013 14:18'!
writeField: field value: val 
	Transcript show: 'Write '; show: field ; show: self class asString;  cr.
	^self  instVarNamed: field put: val. 
	
	! !

RBProgramNodeVisitor subclass: #AmopVisitor
	instanceVariableNames: 'currentClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core'!

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 15:25'!
_acceptSelfMessageNode: messageNode 

	(messageNode needsAmopRewrite) ifTrue: [
		| myself block selector sender arguments proxyMessageNode orignalMessageNode |
			
		"Some messages are hardcoded in the VM, we must make sure they are intercepted as well"
		messageNode mapHardcodedVmMessage. 
		
		myself := self buildVariableNode: 'self'. 
		selector := self buildLiteralNode: messageNode selector. 
		block := self buildSyntheticBlock: messageNode.
		arguments := RBArrayNode statements: messageNode arguments.
		
		proxyMessageNode := RBMessageNode receiver:  myself
		 	selector: #receiverProxy 
			arguments: {}.
		
		orignalMessageNode := RBMessageNode receiver:  proxyMessageNode
		 	selector: #trap:selector:arguments:
			arguments: { block . selector . arguments  }.
		
		messageNode replaceWith: orignalMessageNode.		
		^ super visitNode: orignalMessageNode.
	].

	^ super acceptMessageNode: messageNode.! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 15:30'!
acceptArrayNode: anArrayNode 
	| myself selector sender arguments proxyMessageNode chainMessageNode orignalMessageNode |
	
	anArrayNode children do: [:each | self visitNode: each].
	
	(anArrayNode needsAmopRewrite) ifTrue: [
	
		myself := self buildVariableNode: 'self'. 		
		
		orignalMessageNode := RBMessageNode receiver: myself
			selector: #literalTrap:
			arguments: {  	RBArrayNode statements: anArrayNode statements .	 }.
		
		anArrayNode replaceWith: orignalMessageNode.		
		^ super visitNode: orignalMessageNode.
	].! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 13:43'!
acceptAssignmentNode: anAssignmentNode 
	| myself  field proxyMessageNode trapMessageNode |
	Transcript show: 'Assignemt'.
	
	(currentClass instVarNames includes:  anAssignmentNode variable name ) ifFalse: [
		^ super acceptAssignmentNode: anAssignmentNode 	
	].
	
	"self visitNode: anAssignmentNode variable."
	self visitNode: anAssignmentNode value.
	
	myself := self buildVariableNode: 'self'. 
	field := self buildLiteralNode: anAssignmentNode variable name. 
	
	proxyMessageNode := RBMessageNode receiver:  myself
		 	selector: #receiverProxy 
			arguments: {}.
		
	trapMessageNode := RBMessageNode receiver:  proxyMessageNode
		 	selector: #writeField:value: 
			arguments: { field .  anAssignmentNode value }.
			
	anAssignmentNode replaceWith: trapMessageNode.		
		! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 15:32'!
acceptBlockNode: aBlockNode 
	| myself proxyMessageNode orignalMessageNode |

	(aBlockNode needsAmopRewrite ) ifTrue: [
	
		myself := self buildVariableNode: 'self'. 
		
		orignalMessageNode := RBMessageNode receiver: myself
			selector: #literalTrap:
			arguments: {  	RBBlockNode arguments: aBlockNode arguments body: aBlockNode body }.
		
		aBlockNode replaceWith: orignalMessageNode.		
		^ super visitNode: orignalMessageNode.
	].

	self visitArguments: aBlockNode arguments.
	self visitNode: aBlockNode body.! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 15:31'!
acceptLiteralArrayNode: aRBLiteralArrayNode 
	
	| myself selector sender arguments proxyMessageNode chainMessageNode orignalMessageNode |
	
	aRBLiteralArrayNode contents do: [:each | self visitNode: each].
	
	(aRBLiteralArrayNode needsAmopRewrite) ifTrue: [
	
		myself := self buildVariableNode: 'self'. 
				
		orignalMessageNode := RBMessageNode receiver: myself
			selector: #literalTrap:
			arguments: {  	RBLiteralArrayNode value: aRBLiteralArrayNode value .	 }.
		
		aRBLiteralArrayNode replaceWith: orignalMessageNode.		
		^ super visitNode: orignalMessageNode.
	].! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 15:31'!
acceptLiteralNode: aLiteralNode

	(aLiteralNode needsAmopRewrite) ifTrue: [
		| myself selector sender arguments proxyMessageNode chainMessageNode orignalMessageNode |
			
		myself := self buildVariableNode: 'self'. 
			
		orignalMessageNode := RBMessageNode receiver: myself
			selector: #literalTrap: 
			arguments: { 
				self buildLiteralNode: aLiteralNode value 
			 }.
		
		aLiteralNode replaceWith: orignalMessageNode.		
		^ super visitNode: orignalMessageNode.
	]! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 15:25'!
acceptMessageNode: messageNode 

	( messageNode isNew ) ifTrue: [
		^ self acceptNewMessageNode: messageNode  
	].

	( messageNode isSelfSend ) ifTrue: [  
		 "if logging, special transformation for self and super sends"
		^self acceptNormalMessageNode: messageNode.
	].
	
	( messageNode isSuperSend ) ifTrue: [  
		 "if logging, special transformation for self and super sends"
		^super acceptMessageNode:  messageNode.
	].

	( messageNode isBypass ) ifTrue: [  
		 "if logging, special transformation for self and super sends"
		^super acceptMessageNode:  messageNode.
	].

	^self acceptNormalMessageNode: messageNode.! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 15:28'!
acceptNewMessageNode: messageNode 

	(messageNode needsAmopRewrite) ifTrue: [
		| myself selector sender arguments proxyMessageNode chainMessageNode orignalMessageNode |
			
		myself := self buildVariableNode: 'self'. 
		selector := self buildLiteralNode: messageNode selector. 
		arguments := RBArrayNode statements: messageNode arguments.
			
		orignalMessageNode := RBMessageNode receiver: myself
			selector: #newTrap:
			arguments: { 
				RBMessageNode receiver:  messageNode receiver
		 		selector: #new
				arguments: { } .
			 }.
		
		messageNode replaceWith: orignalMessageNode.		
		^ super visitNode: orignalMessageNode.
	].

	^ super acceptMessageNode: messageNode.! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 12:20'!
acceptNormalMessageNode: messageNode 

	
	(messageNode receiver isLiteral and: [ messageNode receiver value asString first isUppercase] ) ifTrue: [
		^ super acceptMessageNode: messageNode.
	].

	(messageNode needsAmopRewrite) ifTrue: [
		| myself block selector sender arguments proxyMessageNode orignalMessageNode |

		"Some messages are hardcoded in the VM, we must make sure they are intercepted as well"
		messageNode mapHardcodedVmMessage. 
		
		Transcript show: 'Rewrite '; show: messageNode selector; cr. 
		block := self buildSyntheticBlock: messageNode.
		arguments := RBArrayNode statements: messageNode arguments.
		selector := self buildLiteralNode: messageNode selector. 
		
		orignalMessageNode := RBMessageNode receiver:  messageNode receiver 
		 	selector: #trap:selector:arguments:
			arguments: { block . selector . arguments  }.
		
		messageNode replaceWith: orignalMessageNode.		
		^ super visitNode: orignalMessageNode.
	].

	^ super acceptMessageNode: messageNode.! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 15:24'!
acceptVariableNode: aVariableNode

	| myself  field proxyMessageNode trapMessageNode |
	
	(aVariableNode name = 'self'  ) ifTrue: [
		myself := self buildVariableNode: 'self'. 
			
		proxyMessageNode := RBMessageNode receiver:  myself
		 	selector: #receiverProxy 
			arguments: {}.
				
		aVariableNode replaceWith: proxyMessageNode.		
	].
		
	( currentClass instVarNames includes: aVariableNode name ) ifTrue: [
		Transcript show: 'Variable'.
		myself := self buildVariableNode: 'self'. 
		field := self buildLiteralNode: aVariableNode name. 
		
		proxyMessageNode := RBMessageNode receiver:  myself
		 	selector: #receiverProxy 
			arguments: {}.
			
		trapMessageNode := RBMessageNode receiver:  proxyMessageNode
		 	selector: #readField:
			arguments: { field }.
			
		  aVariableNode  replaceWith: trapMessageNode.	
	].	! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 8/28/2012 11:43'!
buildLiteralNode: aName
	| literal |
	literal  := RBLiteralToken value: aName.
	^ RBLiteralValueNode literalToken: literal.! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 9/3/2012 16:29'!
buildSyntheticBlock: messageNode 
| blockBodyMessageArguments blockArguments block blockBody collStatements blockBodyMessage  blockBodyReceiver blockBodyReceiverName blockFirstArg |

		"Build a block of the form
		  [ :receiver :arg | receiver selector: arg ]
		"
		
		" Build the message that will be in the synthetic block"
		blockBodyReceiverName := self nextVariableName.
		blockBodyReceiver := self buildVariableNode: blockBodyReceiverName. 
		blockBodyMessageArguments:= OrderedCollection new.
		blockArguments := OrderedCollection new.
		messageNode arguments size timesRepeat: [ 
			| argName |
			argName := self nextVariableName .
			blockBodyMessageArguments addLast: ( self buildVariableNode: argName ).
			blockArguments addLast: ( self buildVariableNode: argName ).
		].
		blockBodyMessage := RBMessageNode receiver: blockBodyReceiver
			selector: messageNode selector
			arguments: blockBodyMessageArguments.
		
		"Now build the synthetic block itself"
		collStatements := OrderedCollection new.
		collStatements add: blockBodyMessage.
		blockBody := RBSequenceNode statements: collStatements.
		
		blockFirstArg := self buildVariableNode: blockBodyReceiverName. 
		blockArguments addFirst: blockFirstArg.
		
		block := RBAmopBlockNode 
			arguments: blockArguments
			body: blockBody. 
			
		^ block
		! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 8/28/2012 11:44'!
buildVariableNode: aName
	| literal |
	literal  := RBLiteralToken value: aName.
	^ RBVariableNode identifierToken: literal.! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 9/3/2012 16:30'!
nextVariableName
	^ VariableNameCounter nextVariableName 
	! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 9/3/2012 14:26'!
visitNode: aNode class: class
	currentClass := class. 
	^self visitNode: aNode. ! !

RBProgramNodeVisitor subclass: #OwnershipCompilerMessageVisitor3
	instanceVariableNames: 'skip'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Compiler'!

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 6/22/2012 14:00'!
acceptArrayNode: arrayNode 
	| newArrayNode newMessageNode |

	"Exclude certain nodes (see acceptMethodNode)"
	skip ifTrue: [ ^ super acceptArrayNode: arrayNode. ].
	
	(arrayNode isOwnershipArrayNode) ifFalse: [
	
		newArrayNode:= RBOwnershipArrayNode statements: arrayNode statements.
	
		newMessageNode:= RBMessageNode receiver: (self buildVariableNode: 'DOArray')
			selector: #withAll:
			arguments: (OrderedCollection withAll: newArrayNode).
	
		arrayNode replaceWith: newMessageNode.	
		
		^ super visitNode: newMessageNode.
	
	].
	
	^ super acceptArrayNode: arrayNode.! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 6/22/2012 13:59'!
acceptLiteralArrayNode: literalArrayNode 
	| newArrayNode newMessageNode |

	"Exclude certain nodes (see acceptMethodNode)"
	skip ifTrue: [ ^ super acceptLiteralArrayNode: literalArrayNode. ].
	
	(literalArrayNode isOwnershipLiteralArrayNode) ifFalse: [

		newArrayNode:= RBOwnershipArrayNode statements: literalArrayNode contents.

		newMessageNode:= RBMessageNode receiver: (self buildVariableNode: 'DOArray')
			selector: #withAll:
			arguments: (OrderedCollection withAll: newArrayNode).

		literalArrayNode replaceWith: newMessageNode.
		
		^ super visitNode: newMessageNode.
	
	].
	^ super acceptLiteralArrayNode: literalArrayNode.! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 6/27/2012 14:47'!
acceptMessageNode: messageNode 
	| logging |
	"logging = true: self and super will be converted to  self track: [ original method ] selector: #selector"
	logging:= false.
	
	"Excluse certain methods (see acceptMethodNode)"
	skip ifTrue: [ ^super acceptMessageNode: messageNode. ].

	( logging and: [ messageNode isSelfSend or: [messageNode isSuperSend ] ] ) ifTrue: [  
		 "if logging, special transformation for self and super sends"
		^self acceptSelfAndSuperMessageNode: messageNode.
	]
	ifFalse: [
		"normal case"
		^self acceptNormalMessageNode: messageNode.
	].! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'pmaer 7/10/2012 17:05'!
acceptMethodNode: aMethod
	VariableNameCounter resetCounter. 
	skip := aMethod isOwernshipMeta.
	^ super acceptMethodNode: aMethod.
	! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 6/28/2012 09:14'!
acceptNormalMessageNode: messageNode 

	"Exclude self and super sends and few other cases"
	(messageNode isExcluded ) 
		ifTrue: [ ^super acceptMessageNode: messageNode. ].	
		
				
	(messageNode needsOwnershipRewrite) ifTrue: [
		| block selector sender arguments newMessageNode |
			
		"block := self buildVariableNode: 'self'. "
		block := self buildSyntheticBlock: messageNode .
		selector := self buildLiteralNode: messageNode selector. 
		sender := self buildVariableNode: 'self'.
		arguments := RBOwnershipArrayNode statements: messageNode arguments.
				
		newMessageNode:= RBMessageNode receiver:  messageNode receiver
		 	selector: #checkValidSend3:message:block:arguments:
			arguments: { sender. selector. block. arguments}.
		
		messageNode replaceWith: newMessageNode.		
		^ super visitNode: newMessageNode.
	].

	^ super acceptMessageNode: messageNode.! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'pmaer 6/26/2012 16:10'!
acceptSelfAndSuperMessageNode: messageNode 

"Send type logger, special block for this case:"
	
	"Exclude self thisSender"
	(messageNode isSelfSend and: [messageNode selector = #thisSender]) ifTrue: [
		 ^super acceptMessageNode: messageNode.
		].
	
	 ((messageNode isSelfSend or: [ messageNode isSuperSend ])  and: [messageNode needsOwnershipRewrite ])
		ifTrue: [ 
			| block selector arguments newMessageNode receiver |
			
			block:= self buildTrackBlock: messageNode .
			selector := self buildLiteralNode: messageNode selector. 
				
			newMessageNode:= RBMessageNode receiver:  (self buildVariableNode: 'self')
		 	selector: #track:selector:
			arguments: { block. selector.}.
		
			messageNode replaceWith: newMessageNode.
			
			^ super visitNode: newMessageNode.
			
			
			].
	"------------------------------------------"
	^ super acceptMessageNode: messageNode.! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 14:58'!
buildLiteralNode: aName
	| literal |
	literal  := RBLiteralToken value: aName.
	^ RBLiteralValueNode literalToken: literal.! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 15:33'!
buildSyntheticBlock: messageNode 
| blockBodyMessageArguments blockArguments block blockBody collStatements blockBodyMessage  blockBodyReceiver blockBodyReceiverName blockFirstArg |

		"Build a block of the form
		  [ :receiver :arg | receiver selector: arg ]
		"
		
		" Build the message that will be in the synthetic block"
		blockBodyReceiverName := self nextVariableName.
		blockBodyReceiver := self buildVariableNode: blockBodyReceiverName. 
		blockBodyMessageArguments:= OrderedCollection new.
		blockArguments := OrderedCollection new.
		messageNode arguments size timesRepeat: [ 
			| argName |
			argName := self nextVariableName .
			blockBodyMessageArguments addLast: ( self buildVariableNode: argName ).
			blockArguments addLast: ( self buildVariableNode: argName ).
		].
		blockBodyMessage := RBMessageNode receiver: blockBodyReceiver
			selector: messageNode selector
			arguments: blockBodyMessageArguments.
		
		"Now build the synthetic block itself"
		collStatements := OrderedCollection new.
		collStatements add: blockBodyMessage.
		blockBody := RBSequenceNode statements: collStatements.
		
		blockFirstArg := self buildVariableNode: blockBodyReceiverName. 
		blockArguments addFirst: blockFirstArg.
		
		block := RBOwnershipBlockNode 
			arguments: blockArguments
			body: blockBody. 
			
		^ block
		! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'pmaer 6/26/2012 12:09'!
buildTrackBlock: messageNode 
| blockBodyMessageArguments blockArguments block blockBody collStatements blockBodyMessage  blockBodyReceiver blockBodyReceiverName blockFirstArg |

		"Build a block of the form
		  [ :receiver :arg | receiver selector: arg ]
		"
		
		" Build the message that will be in the synthetic block"
		blockBodyReceiver := messageNode receiver.
		blockBodyMessageArguments:= messageNode arguments.

		blockBodyMessage := RBMessageNode receiver: blockBodyReceiver
			selector: messageNode selector
			arguments: blockBodyMessageArguments.
		
		"Now build the synthetic block itself"
		collStatements := OrderedCollection new.
		collStatements add: blockBodyMessage.
		blockBody := RBSequenceNode statements: collStatements.
		
		block := RBOwnershipBlockNode
			body: blockBody. 
		^ block
		! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 14:30'!
buildVariableNode: aName
	| literal |
	literal  := RBLiteralToken value: aName.
	^ RBVariableNode identifierToken: literal.! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 14:29'!
nextVariableName
	^ VariableNameCounter nextVariableName 
	! !

!RBLiteralNode methodsFor: '*amop' stamp: 'ewe 2/7/2013 17:44'!
needsAmopRewrite
	"We do not rewrite the check itself, not the synthetic block passed as argument
	  receiver     check: [ :receiver :arg |  receiver originalSelector: arg ] 
				sender: self 
				arguments: { rewrittenArguments }"
	
	(self parent isMessage and: [ self parent receiver = self  ]) ifTrue: [ ^ true ].
	
	^ ((self parent isMessage and: [ self parent selector = #literalTrap: ]) or: 
	[(self parent isMessage and: [ self parent selector = #trap:selector:arguments:  ])])   not . 
	! !

RBCompiler subclass: #AmopCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core'!

!AmopCompiler methodsFor: 'as yet unclassified' stamp: 'ewe 9/3/2012 14:26'!
translate: aProgramNode
AmopVisitor new visitNode: aProgramNode methodNode class: class ..
^ super translate: aProgramNode.
! !

RBCompiler subclass: #OwnershipCompiler3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Compiler'!

!OwnershipCompiler3 methodsFor: 'as yet unclassified' stamp: 'pmaer 3/26/2012 19:20'!
translate: aProgramNode
OwnershipCompilerMessageVisitor3 new visitNode: aProgramNode methodNode..
^ super translate: aProgramNode.
! !

!RBMessageNode methodsFor: '*amop' stamp: 'ewe 1/31/2013 12:34'!
isBypass
	^false. 
	"^ self selector = #ifTrue::ifFalse: or: [  self selector = #ifFalse:ifTrue: or: [ self selector = #ifTrue: or: [ self selector = #ifFalse: ]]]"! !

!RBMessageNode methodsFor: '*amop' stamp: 'ewe 8/30/2012 10:51'!
isNew
	^ self selector = #new! !

!RBMessageNode methodsFor: '*amop' stamp: 'ewe 2/8/2013 13:15'!
mapHardcodedVmMessage

	( selector = #== ) ifTrue: [
		selector := #identityEquals: .
		^self. 
	].
	( selector = #= ) ifTrue: [
		selector := #equals: .
		^self. 
	].! !

RBBlockNode subclass: #RBAmopBlockNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core'!

!RBAmopBlockNode methodsFor: 'as yet unclassified' stamp: 'ewe 9/3/2012 16:39'!
isAmopBlockNode
	^true! !

!RBAmopBlockNode methodsFor: 'as yet unclassified' stamp: 'ewe 9/12/2012 17:21'!
needsAmopRewrite 
	^false! !

!RBBlockNode methodsFor: '*amop' stamp: 'ewe 9/12/2012 17:32'!
needsAmopRewrite
	"We do not rewrite the check itself, not the synthetic block passed as argument
	  receiver     check: [ :receiver :arg |  receiver originalSelector: arg ] 
				sender: self 
				arguments: { rewrittenArguments }"
	^ ((self parent isMessage and: [ self parent selector = #literalTrap: ] ) )  not . 
	! !

Error subclass: #ReadOnlyError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Tests'!

Error subclass: #RevokedMembraneError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Tests'!

!RBArrayNode methodsFor: '*amop' stamp: 'ewe 9/5/2012 14:10'!
needsAmopRewrite
	"We do not rewrite the check itself, not the synthetic block passed as argument
	  receiver     check: [ :receiver :arg |  receiver originalSelector: arg ] 
				sender: self 
				arguments: { rewrittenArguments }"
	^ ((self parent isMessage and: [ self parent selector = #literalTrap: ] ) or: 
	[  (self parent isMessage and: [ self parent selector = #trap:selector:arguments:  ] ) ] )  not . 
	! !

TestCase subclass: #TestClosureSelf
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Tests'!

!TestClosureSelf methodsFor: 'as yet unclassified' stamp: 'ewe 9/12/2012 16:58'!
instantiateAndSetUp: class handlerClass: handlerClass
	| o  proxyAndHandler |
	BaseTracingHandler reset.
	o := class basicNew.
	proxyAndHandler := Proxy proxyAndHandler: o .
	ProxyHandler receiverProxy: (proxyAndHandler at: 1)  handler: (proxyAndHandler at: 2).
	o initialize.
	"TODO this is fishy... shouldn't it be chained?"
	proxyAndHandler := Proxy proxy: o handlerClass: handlerClass. 
	ProxyHandler receiverProxy: nil  handler: ProxyHandler new.
	Transcript show: '-----------------';cr.
	^ (proxyAndHandler at: 1). ! !

!TestClosureSelf methodsFor: 'as yet unclassified' stamp: 'ewe 2/7/2013 17:31'!
testBooleanClassClosure
	| proxy  res |
	"TODO can closure flow across base and meta level?"
	proxy := self instantiateAndSetUp: Facade handlerClass: ProxyHandler .
	"context doSelfClass  is rewritten as follows by amop compiler"
	res := proxy trap: [ :t1 | t1 doBooleanClassClosure  ] selector: #doBooleanClassClosure arguments:{ } . 
	self assert: ( res= Facade  )  .! !

!TestClosureSelf methodsFor: 'as yet unclassified' stamp: 'ewe 2/7/2013 16:06'!
testHelperClassClosure
	| proxy  res |
	"TODO can closure flow across base and meta level?"
	proxy := self instantiateAndSetUp: Facade handlerClass: ProxyHandler .
	"context doSelfClass  is rewritten as follows by amop compiler"
	res := proxy trap: [ :t1 | t1 doHelperClassClosure  ] selector: #doHelperClassClosure arguments:{ } . 
	self assert: ( res= Facade  )  .! !

!TestClosureSelf methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 11:33'!
testSelfClass
	| proxy  res |
	"TODO can closure flow across base and meta level?"
	proxy := self instantiateAndSetUp: Facade handlerClass: ProxyHandler .
	"context doSelfClass  is rewritten as follows by amop compiler"
	res := proxy trap: [ :t1 | t1 doSelfClass ] selector: #doSelfClass arguments:{ } . 
	self assert: ( res   = Facade )  .! !

!TestClosureSelf methodsFor: 'as yet unclassified' stamp: 'ewe 2/7/2013 16:06'!
testSelfClassClosure
	| proxy  res |
	"TODO can closure flow across base and meta level?"
	proxy := self instantiateAndSetUp: Facade handlerClass: ProxyHandler .
	"context doSelfClass  is rewritten as follows by amop compiler"
	res := proxy trap: [ :t1 | t1 doSelfClassClosure ] selector: #doSelfClassClosure arguments:{ } . 
	self assert: ( res = Facade  )  .! !

TestCase subclass: #TestInstantiation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Tests'!

!TestInstantiation methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 14:25'!
testFactoryNilProxy
self fail.! !

!TestInstantiation methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 14:25'!
testNewNilProxy
self fail.! !

TestCase subclass: #TestMembrane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Tests'!

!TestMembrane methodsFor: 'as yet unclassified' stamp: 'ewe 9/12/2012 16:23'!
instantiateAndSetUp: class 
	| o proxyAndHandler |
	o := class basicNew.
	proxyAndHandler := Proxy proxyAndHandler: o. 
	ProxyHandler receiverProxy: (proxyAndHandler at: 1)  handler: (proxyAndHandler at: 2).
	o initialize.
	ProxyHandler receiverProxy: nil  handler: ProxyHandler new.
	Transcript show: '-----------------';cr.
	^ (proxyAndHandler at: 1). ! !

!TestMembrane methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 14:14'!
testInMembrane
	| tester res |
	tester := self instantiateAndSetUp: MembraneTester .
	res := tester trap: [ :o | o testInMembrane ] selector: #testInMembrane arguments: #() .
	self assert: ( res  baseObject = 42 )  .! !

!TestMembrane methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 14:14'!
testInRevokeMembrane 
	| tester res |
	tester := self instantiateAndSetUp: MembraneTester .
	
	self should: [ 
		 tester trap: [ :o | o testInRevokeMembrane ] selector: #testInRevokeMembrane arguments: #() .
	] raise: RevokedMembraneError! !

!TestMembrane methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 14:14'!
testOutMembrane
	| tester res |
	tester := self instantiateAndSetUp: MembraneTester .
	res := tester trap: [ :o | o testOutMembrane ] selector: #testOutMembrane arguments: #() .
	self assert: ( res  baseObject = 42 )  .! !

!TestMembrane methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 14:14'!
testOutRevokeMembrane 
	| tester res |
	tester := self instantiateAndSetUp: MembraneTester .
	
	self should: [ 
		 tester trap: [ :o | o testOutRevokeMembrane ] selector: #testOutRevokeMembrane arguments: #() .
	] raise: RevokedMembraneError! !

TestCase subclass: #TestReadOnlyChaining
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Tests'!

!TestReadOnlyChaining methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2012 12:15'!
instantiateAndSetUp: class 
	| o  proxyAndHandler |
	o := class basicNew.
	proxyAndHandler := Proxy proxyAndHandler: o .
	ProxyHandler receiverProxy: (proxyAndHandler at: 1)  handler: (proxyAndHandler at: 2).
	o initialize.
	proxyAndHandler := Proxy proxy: (proxyAndHandler at: 1) handlerClass: ReadOnlyChainingHandler. 
	ProxyHandler receiverProxy: nil  handler: ProxyHandler new.
	Transcript show: '-----------------';cr.
	^ (proxyAndHandler at: 1). ! !

!TestReadOnlyChaining methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 11:33'!
testCompuation
	| proxy res |
	proxy := self instantiateAndSetUp: Facade..
	res := proxy trap: [ :o | o computeSum ] selector: #computeSum arguments: #() .
	self assert: ( res  baseObject  = 42 )  .! !

!TestReadOnlyChaining methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 11:33'!
testMemoize
	| proxy res |
	proxy := self instantiateAndSetUp: Facade..
	self should:	[ res := proxy trap: [ :o | o memoizeSum ] selector: #memoizeSum arguments: #() . ] raise: ReadOnlyError .! !

!TestReadOnlyChaining methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 11:33'!
testMock
	| proxy res |
	proxy := self instantiateAndSetUp: Facade..
	res := proxy trap: [ :o | o mockSum ] selector: #mockSum arguments: #() .
	self assert: ( res  baseObject  = 42 )  .! !

TestCase subclass: #TestTracing
	uses: TNoopTrap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Tests'!

TestTracing class
	uses: TNoopTrap classTrait
	instanceVariableNames: ''!

!TestTracing methodsFor: 'as yet unclassified' stamp: 'ewe 9/12/2012 16:22'!
instantiateAndSetUp: class handlerClass: handlerClass
	| o  proxyAndHandler |
	BaseTracingHandler reset.
	o := class basicNew.
	proxyAndHandler := Proxy proxyAndHandler: o .
	ProxyHandler receiverProxy: (proxyAndHandler at: 1)  handler: (proxyAndHandler at: 2).
	o initialize.
	"TODO this is fishy... shouldn't it be chained?"
	proxyAndHandler := Proxy proxy: o handlerClass: handlerClass. 
	ProxyHandler receiverProxy: nil  handler: ProxyHandler new.
	Transcript show: '-----------------';cr.
	^ (proxyAndHandler at: 1). ! !

!TestTracing methodsFor: 'as yet unclassified' stamp: 'ewe 2/6/2013 17:29'!
testClosure
	| proxy context res block |
	"TODO can closure flow across base and meta level?"
	proxy :=  Facade basicNew. 
	ProxyHandler receiverProxy:  proxy handler: #NoHandler.. 
	proxy initialize. 
	context := self instantiateAndSetUp: Scope handlerClass: TracingHandlerSelfSend .
	" [ :o |  o twiceComputeSum ] is rewritten as follows by amop compiler "
	"closures are literal that must be wrapped"
	block  := ClosureProxy for:  [ :o | o  trap: [ :t1 | t1 twiceComputeSum ] selector: #twiceComputeSum arguments: #() . ].
	"context do: block with: proxy is rewritten as follows by amop compiler"
	res := context trap: [ :t1 :t2 :t3 | t1 do: t2 with: t3 ] selector: #do:with: arguments:{ block. proxy } . 
	self assert: ( res  handler target  = 84 )  .
	self assert: ( BaseTracingHandler counter = 9 )  . ! !

!TestTracing methodsFor: 'as yet unclassified' stamp: 'ewe 2/6/2013 17:32'!
testClosure2
	| proxy context res block |
	"TODO can closure flow across base and meta level?"
	proxy := self instantiateAndSetUp: Facade handlerClass: ProxyHandler .
	context := self instantiateAndSetUp: Scope handlerClass: TracingHandlerSelfSend .
	" [ :o |  o twiceComputeSum ] is rewritten as follows by amop compiler "
	block  := ClosureProxy for:  [ :o | o  trap: [ :t1 | t1 twiceComputeSum ] selector: #twiceComputeSum arguments: #() . ].
	"context do: block with: proxy is rewritten as follows by amop compiler"
	res := context trap: [ :t1 :t2 :t3 | t1 do: t2 with: t3 ] selector: #do:with: arguments:{ block. proxy } . 
	self assert: ( res  handler target  = 84 )  .
	self assert: ( BaseTracingHandler counter = 9 )  .! !

!TestTracing methodsFor: 'as yet unclassified' stamp: 'ewe 2/6/2013 17:33'!
testNoSelfSendAndNoSelfTracing 
	| proxy res |
	proxy := self instantiateAndSetUp: Facade handlerClass: TracingHandlerNoSelfSend .
	res := proxy trap: [ :o | o computeSum ] selector: #computeSum arguments: #() .
	self assert: ( res  handler target  = 42 )  .
	self assert: ( BaseTracingHandler counter = 3 )  .! !

!TestTracing methodsFor: 'as yet unclassified' stamp: 'ewe 2/6/2013 17:35'!
testNoSelfSendAndSelfTracing 
	| proxy res |
	proxy := self instantiateAndSetUp: Facade handlerClass: TracingHandlerSelfSend .
	res := proxy trap: [ :o | o computeSum ] selector: #computeSum arguments: #() .
	self assert: ( res  handler target  = 42 )  .
	self assert: ( BaseTracingHandler counter = 3 )  .! !

!TestTracing methodsFor: 'as yet unclassified' stamp: 'ewe 2/7/2013 15:28'!
testSelfSendAndNoSelfTracing 
	| proxy res |
	proxy := self instantiateAndSetUp: Facade handlerClass: TracingHandlerNoSelfSend .
	res := proxy trap: [ :o | o twiceComputeSum ] selector: #twiceComputeSum arguments: #() .
	self assert: ( res  handler target  = 84 )  .
	self assert: ( BaseTracingHandler counter = 5 )  .! !

!TestTracing methodsFor: 'as yet unclassified' stamp: 'ewe 2/7/2013 15:28'!
testSelfSendAndSelfTracing 
	| proxy res |
	proxy := self instantiateAndSetUp: Facade handlerClass: TracingHandlerSelfSend .
	res := proxy trap: [ :o | o twiceComputeSum ] selector: #twiceComputeSum arguments: #() .
	self assert: ( res  handler target  = 84 )  .
	self assert: ( BaseTracingHandler counter = 7 )  .! !

!TestTracing methodsFor: 'as yet unclassified' stamp: 'ewe 2/7/2013 15:29'!
testTracingReadonly
	| proxy context res block |
	"TODO can closure flow across base and meta level?"
	proxy := self instantiateAndSetUp: Facade handlerClass: ProxyHandler .
	context := self instantiateAndSetUp: Scope handlerClass: TracingHandlerSelfSend .
	context := Proxy for: context handlerClass: ReadOnlyChainingHandler.
	" [ :o |  o twiceComputeSum ] is rewritten as follows by amop compiler "
	block  := Proxy for:  [ :o | o  trap: [ :t1 | t1 twiceComputeSum ] selector: #twiceComputeSum arguments: #() . ].
	res := context trap: [ :t1 :t2 :t3 | t1 do: t2 with: t3 ] selector: #do:with: arguments:{ block. proxy } . 
	self assert: ( res  handler target  = 84 )  .
	self assert: ( BaseTracingHandler counter = 9 )  .! !

TestCase subclass: #TestTransparency
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Tests'!

!TestTransparency methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2012 12:15'!
instantiateAndSetUp: class 
	| o proxyAndHandler |
	o := class basicNew.
	proxyAndHandler := Proxy proxyAndHandler: o. 
	ProxyHandler receiverProxy: (proxyAndHandler at: 1)  handler: (proxyAndHandler at: 2).
	o initialize.
	ProxyHandler receiverProxy: nil  handler: ProxyHandler new.
	Transcript show: '-----------------';cr.
	^ (proxyAndHandler at: 1). ! !

!TestTransparency methodsFor: 'as yet unclassified' stamp: 'ewe 1/30/2013 14:59'!
testCompuation
	| proxy res |
	proxy := self instantiateAndSetUp: Facade..
	res := proxy trap: [ :o | o computeSum ] selector: #computeSum arguments: #() .
	self assert: ( res handler target = 42 )  .! !

!TestTransparency methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 12:16'!
testIdentity
	| o proxy1 proxy2 proxyAndHandler res |
	o := Facade basicNew. 
	proxyAndHandler  := Proxy proxyAndHandler: o. 
	ProxyHandler receiverProxy: (proxyAndHandler at: 1)  handler: (proxyAndHandler at: 2).
	o initialize.
	ProxyHandler receiverProxy: nil  handler: ProxyHandler new.
	proxy1 := proxyAndHandler at: 1. 
	proxyAndHandler  := Proxy proxyAndHandler: o. 
	proxy2 := proxyAndHandler at: 1. 
	Transcript show: '-----------------';cr.
	res := proxy1 trap: [ :o1 :o2 | o1 isEqualTo:  o2 ] selector: #isEqualTo: arguments: { proxy2 } .
	self assert: ( res = true  )  .! !

!TestTransparency methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 14:08'!
testIdentity2
	| o proxy1 proxy2 proxyAndHandler res |
	o := Facade basicNew. 
	proxyAndHandler  := Proxy proxyAndHandler: o. 
	ProxyHandler receiverProxy: (proxyAndHandler at: 1)  handler: (proxyAndHandler at: 2).
	o initialize.
	ProxyHandler receiverProxy: nil  handler: ProxyHandler new.
	proxy1 := proxyAndHandler at: 1. 
	proxyAndHandler  := Proxy proxyAndHandler: o. 
	proxy2 := proxyAndHandler at: 1. 
	Transcript show: '-----------------';cr.
	res := proxy1 trap: [ :o1 :o2 | o1 isEqualTo2:  o2 ] selector: #isEqualTo2: arguments: { proxy2 } .
	self assert: ( res = true  )  .! !

!TestTransparency methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 11:33'!
testMemoize
	| proxy res |
	proxy := self instantiateAndSetUp: Facade..
	res := proxy trap: [ :o | o memoizeSum ] selector: #memoizeSum arguments: #() .
	self assert: ( res  handler target  = 42 )  .! !

!TestTransparency methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 11:33'!
testMock
	| proxy res |
	proxy := self instantiateAndSetUp: Facade..
	res := proxy trap: [ :o | o mockSum ] selector: #mockSum arguments: #() .
	self assert: ( res  handler target = 42 )  .! !

!TestTransparency methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 11:33'!
testReturn42
 	| proxy res  |
	proxy := self instantiateAndSetUp: Facade.
	res := proxy trap: [ :o | o return42 ] selector: #return42 arguments: #() .
	self assert: ( res  handler target  = 42 )  .
	res := proxy trap: [ :o | o selfReturn42 ] selector: #selfReturn42 arguments: #() .
	self assert: ( res  handler target  = 42 )  .
	proxy := self instantiateAndSetUp: SubFacade.
	res := proxy trap: [ :o | o return42 ] selector: #return42 arguments: #() .
	self assert: ( res  handler target  = 42 )  .
	res := proxy trap: [ :o | o selfReturn42 ] selector: #selfReturn42 arguments: #() .
	self assert: ( res  handler target  = 42 )  .! !

!TestTransparency methodsFor: 'as yet unclassified' stamp: 'ewe 1/28/2013 11:53'!
testReturnObject
	| proxy res |
	proxy := self instantiateAndSetUp: Facade.
	res := proxy trap: [ :o | o returnObject ] selector: #returnObject arguments: #() .
	self assert: ( res  = nil ) not   .
	res := proxy trap: [ :o | o selfReturnObject ] selector: #selfReturnObject arguments: #() .
	self assert: ( res   = nil ) not  .
	proxy := self instantiateAndSetUp: SubFacade.
	res := proxy trap: [ :o | o returnObject ] selector: #returnObject  arguments: #() .
	self assert: ( res  = nil ) not   .
	res := proxy trap: [ :o | o selfReturnObject ] selector: #selfReturnObject arguments: #() .! !

!TestTransparency methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 14:11'!
testReturnSelf
 	| proxy res  |
	proxy := self instantiateAndSetUp: Facade.
	res := proxy trap: [ :o | o returnSelf ] selector: #returnSelf arguments: #() .
	self assert: ( res  == proxy  )  .
	res := proxy trap: [ :o | o selfReturnSelf ] selector: #selfReturnSelf arguments: #() .
	self assert: (  res  == proxy )  .
	proxy := self instantiateAndSetUp: SubFacade.
	res := proxy trap: [ :o | o returnSelf ] selector: #returnSelf arguments: #() .
	self assert: ( res  == proxy )  .
	res := proxy trap: [ :o | o selfReturnSelf ] selector: #selfReturnSelf arguments: #() .
	self assert: (  res  == proxy )  .! !

Object subclass: #BaseObject
	uses: TNoopTrap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core'!

BaseObject class
	uses: TNoopTrap classTrait
	instanceVariableNames: ''!

!BaseObject methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2012 14:16'!
receiverProxy 
	"TODO walk up the chain until the LAST proxy, consider chains of proxy and super sends"
	"self receiverProxy returns the caller of the current activation"
	^ ProxyHandler receiverProxy.! !

!BaseObject methodsFor: 'as yet unclassified' stamp: 'ewe 8/28/2012 11:47'!
test
	^ self xxx     ! !

BaseObject subclass: #Facade
	instanceVariableNames: 'helper'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Tests'!

!Facade class methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2012 14:39'!
compilerClass 
	^AmopCompiler! !

!Facade class methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2012 12:16'!
newp
	^ Proxy for: self new. ! !

!Facade methodsFor: 'as yet unclassified' stamp: 'ewe 2/7/2013 16:03'!
clazz
	^ self class ! !

!Facade methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 14:22'!
computeSum
 	^ helper compute: 21 sum: 21 .  ! !

!Facade methodsFor: 'as yet unclassified' stamp: 'ewe 2/7/2013 17:40'!
doBooleanClassClosure
"TODO should be wrapped"
	^   true ifTrue: [ self clazz ]  
   ! !

!Facade methodsFor: 'as yet unclassified' stamp: 'ewe 2/7/2013 16:04'!
doHelperClassClosure
"TODO should be wrapped"
^ helper do:  [ self clazz ].       
   ! !

!Facade methodsFor: 'as yet unclassified' stamp: 'ewe 2/7/2013 16:04'!
doSelfClass
"TODO should be wrapped"
^   self clazz. 
 ! !

!Facade methodsFor: 'as yet unclassified' stamp: 'ewe 2/7/2013 16:04'!
doSelfClassClosure
"TODO should be wrapped"
^  [ self clazz ] value.       
   ! !

!Facade methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 12:11'!
initialize 
	helper := Helper new.. 
	helper reset.! !

!Facade methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 15:25'!
isEqualTo2: anotherObject 
 
	^ anotherObject == self  ! !

!Facade methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 15:25'!
isEqualTo: anotherObject 

	^ self == anotherObject. ! !

!Facade methodsFor: 'as yet unclassified' stamp: 'ewe 9/3/2012 12:12'!
memoizeSum
 	^ helper memoize: 20 sum: 22 . ! !

!Facade methodsFor: 'as yet unclassified' stamp: 'ewe 9/3/2012 12:12'!
mockSum 
 	^ helper mock: 0 sum: 0 . ! !

!Facade methodsFor: 'as yet unclassified' stamp: 'ewe 8/28/2012 12:01'!
return42
	^ 42! !

!Facade methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2012 12:04'!
returnObject
	^ Object new. ! !

!Facade methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 14:09'!
returnSelf
	^ self ! !

!Facade methodsFor: 'as yet unclassified' stamp: 'ewe 9/3/2012 16:52'!
selfReturn42
	^ self return42! !

!Facade methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2012 10:47'!
selfReturnObject
	^ self returnObject  ! !

!Facade methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 14:10'!
selfReturnSelf
	^ self returnSelf  ! !

!Facade methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2012 11:09'!
twiceComputeSum
 	^ self computeSum + self computeSum ! !

!Facade methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2012 11:09'!
twiceMemoizeSum
 	^ self memoizeSum + self memoizeSum ! !

!Facade methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2012 11:09'!
twiceMockSum
 	^ self mockSum  + self mockSum ! !

Facade subclass: #SubFacade
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Tests'!

!SubFacade methodsFor: 'as yet unclassified' stamp: 'ewe 8/28/2012 12:02'!
return42
	^super return42.! !

!SubFacade methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2012 10:48'!
returnObject 
	^super returnObject.! !

!SubFacade methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2012 10:47'!
selfReturn42
	^ super selfReturn42 ! !

!SubFacade methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2012 10:48'!
selfReturnObject
	^ super selfReturnObject! !

BaseObject subclass: #Helper
	instanceVariableNames: 'key value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Tests'!

!Helper class methodsFor: 'as yet unclassified' stamp: 'ewe 9/3/2012 14:15'!
compilerClass 
	^AmopCompiler! !

!Helper methodsFor: 'as yet unclassified' stamp: 'ewe 1/31/2013 12:22'!
compute: v1 sum: v2 
	^v1 + v2. ! !

!Helper methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 11:14'!
do: aBlock
	^ aBlock value. ! !

!Helper methodsFor: 'as yet unclassified' stamp: 'ewe 1/31/2013 12:48'!
memoize: v1 sum: v2
	( key = { v1 . v2 } ) ifFalse: [  
		key := { v1 . v2 }.   
		value := v1 + v2  
	]. 
	^ value.   ! !

!Helper methodsFor: 'as yet unclassified' stamp: 'ewe 9/3/2012 12:05'!
mock: v1 sum: v2
	^42! !

!Helper methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 12:11'!
reset
	key := nil.
	value:= nil. ! !

BaseObject subclass: #Holder
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Tests'!

!Holder class methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 11:42'!
compilerClass
	^ AmopCompiler ! !

!Holder methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 11:54'!
get
	^value ! !

!Holder methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 11:42'!
reset
	value := nil. ! !

!Holder methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 11:54'!
set: val
	value := val. ! !

BaseObject subclass: #MembraneTester
	instanceVariableNames: 'membrane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Tests'!

!MembraneTester class methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 13:41'!
compilerClass 
	^AmopCompiler ! !

!MembraneTester methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 14:22'!
setInUp
	| safe wrappedDevious devious |

	devious := Holder new.
	membrane := Membrane new. 
	wrappedDevious := membrane proxyFor: devious. 
	
	safe := Holder new. 
	safe set: 42. 
		
	wrappedDevious set: safe .
	
	^ devious  .! !

!MembraneTester methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 14:06'!
setOutUp
	| safe wrappedDevious devious |

	devious := Holder new.
	devious set: 42. 
	
	membrane := Membrane new. 
	wrappedDevious := membrane proxyFor: devious. 
	
	safe := Holder new. 
	safe set: wrappedDevious.
	
	^ safe.! !

!MembraneTester methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 14:24'!
testInMembrane  
	| devious |
	devious := self setInUp. 
	^ devious get get .	! !

!MembraneTester methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 14:24'!
testInRevokeMembrane 
	| devious |
	devious := self setInUp. 
	membrane revoke. 
	^ devious get get .	! !

!MembraneTester methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 14:07'!
testOutMembrane 
	| safe |
	safe := self setOutUp. 
	^ safe get get .
	! !

!MembraneTester methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 14:07'!
testOutRevokeMembrane 
	| safe |
	safe := self setOutUp. 
	membrane revoke. 
	^ safe get get .
	! !

BaseObject subclass: #Scope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Tests'!

!Scope class methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2012 14:39'!
compilerClass 
	^AmopCompiler! !

!Scope methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2012 14:39'!
do: aBlock with: o 
	"TODO raise execption if block has bound variable "
	^ aBlock value: o ! !

Object subclass: #MetaObject
	uses: TNoopTrap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core'!

MetaObject class
	uses: TNoopTrap classTrait
	instanceVariableNames: ''!

MetaObject subclass: #Membrane
	instanceVariableNames: 'references revoked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Tests'!

!Membrane methodsFor: 'as yet unclassified' stamp: 'ewe 9/12/2012 16:01'!
add: reference
	references add: reference. ! !

!Membrane methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 13:45'!
initialize
	references := IdentitySet new.
	revoked := false! !

!Membrane methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 13:45'!
isRevoked 
	^ revoked ! !

!Membrane methodsFor: 'as yet unclassified' stamp: 'ewe 9/12/2012 16:04'!
proxyFor: aTarget
	| proxy handler |
	handler := MembraneHandler new. 
	handler target: aTarget.
	handler membrane: self. 
	proxy := Proxy handler: handler. 
	self add: proxy. 
	^proxy! !

!Membrane methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 14:04'!
revoke
	revoked := true. 
	references do: [ :ref  | ref handler revoke ].! !

MetaObject subclass: #OriginalProxyHandler
	instanceVariableNames: 'target'
	classVariableNames: 'Receiver ReceiverHandler'
	poolDictionaries: ''
	category: 'Amop-Core'!

!OriginalProxyHandler class methodsFor: 'as yet unclassified' stamp: 'ewe 1/22/2013 16:33'!
receiverProxy
	^Receiver ! !

!OriginalProxyHandler class methodsFor: 'as yet unclassified' stamp: 'ewe 1/22/2013 16:33'!
receiverProxy: anObject 
	^ Receiver := anObject.! !

!OriginalProxyHandler class methodsFor: 'as yet unclassified' stamp: 'ewe 1/22/2013 16:33'!
receiverProxy: anObject handler: aHandler
	 Receiver := anObject.
	  ReceiverHandler:=aHandler.! !

!OriginalProxyHandler class methodsFor: 'as yet unclassified' stamp: 'ewe 1/22/2013 16:33'!
receiverProxyHandler
	^ReceiverHandler! !

!OriginalProxyHandler class methodsFor: 'as yet unclassified' stamp: 'ewe 1/22/2013 16:33'!
target: aTarget
	^ self new target: aTarget ; yourself. ! !

!OriginalProxyHandler methodsFor: 'trap' stamp: 'ewe 1/22/2013 16:33'!
literalTrapContinue: proceed 
	^ ValueProxy for: proceed value.! !

!OriginalProxyHandler methodsFor: 'trap' stamp: 'ewe 1/22/2013 16:33'!
messageIn: aMessage sender: senderHandler continue: proceed
	^ proceed value: aMessage arguments.! !

!OriginalProxyHandler methodsFor: 'trap' stamp: 'ewe 1/22/2013 16:33'!
messageOut: aMessage receiver: receiverHandler continue: proceed
	^ proceed value: aMessage arguments. ! !

!OriginalProxyHandler methodsFor: 'trap' stamp: 'ewe 1/22/2013 16:33'!
newTrapContinue: proceed 
	^ Proxy for:  proceed value.! !

!OriginalProxyHandler methodsFor: 'trap' stamp: 'ewe 1/22/2013 16:33'!
readField: aField  continue: proceed
	^ proceed value.! !

!OriginalProxyHandler methodsFor: 'accessor' stamp: 'ewe 1/22/2013 16:33'!
target
	^ target.! !

!OriginalProxyHandler methodsFor: 'accessor' stamp: 'ewe 1/22/2013 16:33'!
target: aTarget
	target := aTarget.! !

!OriginalProxyHandler methodsFor: 'trap' stamp: 'ewe 1/22/2013 16:33'!
writeField: aField value: aValue continue: proceed
	^ proceed value: aValue.! !

MetaObject subclass: #Proxy
	instanceVariableNames: 'handler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core'!

!Proxy class methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 15:38'!
for: aTarget
	^ self for: aTarget handlerClass: ProxyHandler ! !

!Proxy class methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 15:27'!
for: aTarget handlerClass: handlerClass
	| proxAndHandler |
	proxAndHandler := self proxy: aTarget handlerClass: handlerClass. 
	^ proxAndHandler at: 1. ! !

!Proxy class methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2012 11:47'!
handler: aHandler
	^ self new handler: aHandler ; yourself.! !

!Proxy class methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 15:26'!
proxy: aTarget handlerClass: handlerClass
	| proxy handler |
	handler := handlerClass target: aTarget. 
	proxy := self handler: handler. 
	"ProxyTrap adoptInstance:  proxy. "
	^ { proxy . handler }. ! !

!Proxy class methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 15:27'!
proxyAndHandler: aTarget
	^ self proxy: aTarget handlerClass: ProxyHandler. ! !

!Proxy methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 13:51'!
_selfProxy
	self flag: 'Ugly design'. 
	^self target selfProxy ! !

!Proxy methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 13:51'!
_selfProxyHandler 
	self flag: 'Ugly design'. 
	^self target selfProxyHandler  ! !

!Proxy methodsFor: 'handler-proxy-chain' stamp: 'ewe 9/5/2012 11:52'!
baseObject 
	| target |
	target  := handler target .
	target isAmopProxy ifTrue: [ 
		^ target baseObject. .
	].
	^ target. ! !

!Proxy methodsFor: 'as yet unclassified' stamp: 'ewe 1/31/2013 12:13'!
chainFrom: previousHandler trap: block selector: selector  arguments: arguments
	
	| sender receiver senderHandler receiverHandler target message |
		
	target := handler target.  
	Transcript show:  self class asString ; show: '[' ; show:  self handler class asString ;
		 show: '@'; show: target class asString ; show: ']>>chainTrap ' ; show: selector ; cr.
	
	"We do not rebind self"
	senderHandler := previousHandler.
	receiverHandler := handler.
	
	message := Message selector: selector  arguments: arguments .
	
	"Invoke 
	(1) param out on the sender, (2) param in on the receiver, 
	(3) delegate processing of the message
	(4) return out on the receiver, (5) return in on the sender "
		
	target isAmopProxy ifTrue: [
		^ "senderHandler messageOut: message receiver: receiverHandler continue: [ :argsOut |"
			receiverHandler messageIn: message sender: senderHandler continue: [ :argsIn |
				self transformOutRet: (target chainFrom: receiverHandler  trap: block selector: selector arguments: (self transformInArgs: argsIn ) )]
			"]" .
	] ifFalse: [
		^ "senderHandler messageOut: message receiver: receiverHandler continue: [ :argsOut |"
			receiverHandler messageIn: message sender: senderHandler continue: [ :argsIn |
				| targetWithArgs |
				targetWithArgs := OrderedCollection new.
				targetWithArgs add: target. 
				targetWithArgs addAll: (self transformInArgs: argsIn ). 
				self transformOutRet: ( block valueWithArguments: targetWithArgs) ] 
			"]" .
	]
	

	! !

!Proxy methodsFor: 'handler-proxy-chain' stamp: 'ewe 9/4/2012 11:44'!
handler
 ^handler! !

!Proxy methodsFor: 'handler-proxy-chain' stamp: 'ewe 8/31/2012 11:45'!
handler: aHandler
	handler := aHandler. ! !

!Proxy methodsFor: 'handler-proxy-chain' stamp: 'ewe 2/8/2013 13:54'!
handlers 
	| target|
	target := handler target.  
	target isAmopProxy ifTrue:  [
		^  { handler } , target handlers.  	
	] ifFalse: [
		^ { handler } . 
	]! !

!Proxy methodsFor: 'handler-proxy-chain' stamp: 'ewe 9/5/2012 10:36'!
isAmopProxy 
	^true! !

!Proxy methodsFor: 'handler-proxy-chain' stamp: 'ewe 1/31/2013 13:26'!
isValueProxy
	| target|
	target := handler target.  
	target isAmopProxy ifTrue:  [
		^ target isValueProxy.. 	
	] ifFalse: [
		^ false. 
	]! !

!Proxy methodsFor: 'handler-proxy-chain' stamp: 'ewe 2/8/2013 13:58'!
lastHandler
	^self handlers last. ! !

!Proxy methodsFor: 'handler-proxy-chain' stamp: 'ewe 2/8/2013 13:58'!
lastProxy
	^ self proxies last. ! !

!Proxy methodsFor: 'as yet unclassified' stamp: 'ewe 1/31/2013 12:19'!
literalTrap: argument
	|  target  |
	target := handler target. .
	"TODO do not wrap closure into ValueProxy, but regular Proxy"
	Transcript show:  self class asString ; show: '[' ; show:  self handler class asString ;
		 show: '@'; show: target class asString ; show: ']>>literalTrap ' ; show: '@'; show: target class asString ; cr.
	
	target isAmopProxy ifTrue: [
		^ handler literalTrapContinue: [ target literalTrap: argument ].
	] ifFalse: [
		^ handler literalTrapContinue: [ argument ].
	]! !

!Proxy methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 11:20'!
newTrap: argument
	|  target  |
	target := handler target.
	Transcript show: 'Proxy[' ; show:  self handler class asString ; show: ']>>newTrap ' ; show: '@'; show: target class asString ; cr.
	target isAmopProxy ifTrue: [
		^ handler newTrapContinue: [ target newTrapContinue: argument ].
	] ifFalse: [
		^ handler newTrapContinue: [ argument ].
	]
	
	! !

!Proxy methodsFor: 'handler-proxy-chain' stamp: 'ewe 2/8/2013 13:54'!
proxies 
	| target|
	target := handler target.  
	target isAmopProxy ifTrue:  [
		^  { self } , target proxies.  	
	] ifFalse: [
		^ { self } . 
	]! !

!Proxy methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 11:20'!
readField: field 
	|  target  |
	target := handler target.  
	Transcript show: 'Proxy[' ; show:  self handler class asString ; show: ']>>readField ' ; show: field ; show: '@'; show: target class asString ; cr.
	target isAmopProxy ifTrue: [
		^ handler readField: field 
				continue: [ target readField: field ]
	] ifFalse: [
		^ handler readField: field 
				continue: [ target instVarNamed: field ]
	]
	
	! !

!Proxy methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 10:37'!
target
	^handler target! !

!Proxy methodsFor: 'control' stamp: 'ewe 1/31/2013 11:47'!
transformInArgs: args
	^ args.! !

!Proxy methodsFor: 'control' stamp: 'ewe 1/31/2013 11:48'!
transformOutRet: retVal
	^ retVal ! !

!Proxy methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 12:21'!
trap: block selector: selector arguments: arguments
	
	| sender receiver senderHandler receiverHandler target message |
		
	target := handler target.  
	Transcript show:  self class asString ; show: '[' ; show:  self handler class asString ;
		 show: '@'; show: target class asString ; show: ']>>trap ' ; show: selector ; cr.
	
	"sender of this message is the old receiver"
	sender := ProxyHandler receiverProxy. 
	senderHandler := ProxyHandler receiverProxyHandler.
	"now swap the receiver"
	receiver := self.
	receiverHandler := handler.
	ProxyHandler receiverProxy:  receiver handler: receiverHandler.. 

	message := Message selector: selector  arguments: arguments .
	
	"Invoke 
	(1) param out on the sender, (2) param in on the receiver, 
	(3) delegate processing of the message
	(4) return out on the receiver, (5) return in on the sender "
		
	[ 
		target isAmopProxy ifTrue: [
			^ "senderHandler messageOut: message receiver: receiverHandler continue: [ :argsOut |"
				receiverHandler messageIn: message sender: senderHandler continue: [ :argsIn |
					self transformOutRet: (target chainFrom: receiverHandler  trap: block selector: selector arguments: ( self transformInArgs: argsIn) ) ]
				"]" .
		] ifFalse: [
			^ "senderHandler messageOut: message receiver: receiverHandler continue: [ :argsOut |"
				receiverHandler messageIn: message sender: senderHandler continue: [ :argsIn |
					| targetWithArgs |
					targetWithArgs := OrderedCollection new.
					targetWithArgs add: target. 
					targetWithArgs addAll: (self transformInArgs: argsIn ) . 
					self transformOutRet: ( block valueWithArguments: targetWithArgs ) ]
				" ]" .
		]
	] ensure: [
		ProxyHandler receiverProxy:  sender handler: senderHandler.. 
	]
	

	! !

!Proxy methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 13:56'!
writeField: field value: value
	|  target  |
	target := handler target.  
	Transcript show: 'Proxy[' ; show:  self handler class asString ; show: ']>>writeField ' ; show: field ;show: '@';  show: target class asString ; cr.
	target isAmopProxy ifTrue: [
		^ handler writeField: field
				value: value  
				continue: [ :val |  target writeField: field value: val ]
	] ifFalse: [
		^ handler writeField: field 
			 value: value
				continue: [ :val | target instVarNamed: field 
							      put: val ]
	]! !

Proxy subclass: #ValueProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core'!

ValueProxy subclass: #BooleanProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core'!

!BooleanProxy methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 13:50'!
chainFrom: previousHandler trap: block selector: selector  arguments: arguments
	
	| sender receiver senderHandler receiverHandler target message |
	
	( selector beginsWith: 'if' ) ifFalse: [ Error signal:  'support only evalution of conditionals' ]. 
	
	"sender of this message is the old receiver"
	sender := ProxyHandler receiverProxy. 
	senderHandler := ProxyHandler receiverProxyHandler.
	
	">>rebind the outer context of the closure. See issue 0". 
	receiver := arguments first lastProxy selfProxy.
	receiverHandler := arguments first lastProxy selfProxyHandler . 
	ProxyHandler receiverProxy:  receiver handler: receiverHandler.. 

	[
		^super chainFrom: previousHandler trap: block selector: selector  arguments: arguments. 
	] ensure: [
		ProxyHandler receiverProxy:  sender handler: senderHandler.. 
	]! !

!BooleanProxy methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 13:59'!
trap: block selector: selector arguments: arguments
	
	| sender receiver senderHandler receiverHandler target message |
	
	( selector beginsWith: 'if' ) ifFalse: [ Error signal:  'support only evalution of conditionals' ]. 
	
	target := handler target.  
	Transcript show:  self class asString ; show: '[' ; show:  self handler class asString ;
		 show: '@'; show: target class asString ; show: ']>>trap ' ; show: selector ; cr.

	Transcript show: 'Rewire closure: '; show: arguments first lastProxy selfProxy class asString ; cr. 
	"sender of this message is the old receiver"
	sender := ProxyHandler receiverProxy. 
	senderHandler := ProxyHandler receiverProxyHandler.
	
	"****rebind the outer context of the closure. See issue 0". 
	receiver := arguments first lastProxy selfProxy.
	receiverHandler := arguments first lastProxy selfProxyHandler . 
	ProxyHandler receiverProxy:  receiver handler: receiverHandler.. 

	message := Message selector: selector  arguments: arguments .
	
	self flag: 'Need review -- should we call messageIn, problem of NoHandler'. 
	[ 
			| targetWithArgs |
			targetWithArgs := OrderedCollection new.
			targetWithArgs add: target. 
			targetWithArgs addAll: (self transformInArgs: arguments ) . 
			^  block valueWithArguments: targetWithArgs .
	] ensure: [
		ProxyHandler receiverProxy:  sender handler: senderHandler.. 
	]
	

	! !

ValueProxy subclass: #ClosureProxy
	instanceVariableNames: 'selfProxy selfProxyHandler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core'!

!ClosureProxy class methodsFor: 'as yet unclassified' stamp: 'ewe 2/7/2013 15:58'!
for: aClosure selfProxy: receiverProxy selfProxyHandler: receiverProxyHandler  
	| p |
	p := super for: aClosure. 
        p selfProxy: receiverProxy selfProxyHandler: receiverProxyHandler .
	^p. ! !

!ClosureProxy methodsFor: 'as yet unclassified' stamp: 'ewe 2/7/2013 15:59'!
selfProxy
	^selfProxy ! !

!ClosureProxy methodsFor: 'as yet unclassified' stamp: 'ewe 2/7/2013 15:59'!
selfProxy: receiverProxy selfProxyHandler: receiverProxyHandler 
	selfProxy := receiverProxy .
	selfProxyHandler:=receiverProxyHandler .! !

!ClosureProxy methodsFor: 'as yet unclassified' stamp: 'ewe 2/7/2013 15:59'!
selfProxyHandler
	^selfProxyHandler ! !

!ClosureProxy methodsFor: 'as yet unclassified' stamp: 'ewe 2/6/2013 17:28'!
transformInArgs: args
	^ args! !

!ClosureProxy methodsFor: 'as yet unclassified' stamp: 'ewe 2/6/2013 17:28'!
transformOutRet: retVal
	^ retVal ! !

!ClosureProxy methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 13:51'!
trap: block selector: selector arguments: arguments
	
	| sender receiver senderHandler receiverHandler target message |
	
	( selector beginsWith: 'value' ) ifFalse: [ Error signal:  'support only evalution of closure' ]. 
	
	target := handler target.  
	Transcript show:  self class asString ; show: '[' ; show:  self handler class asString ;
		 show: '@'; show: target class asString ; show: ']>>trap ' ; show: selector ; cr.
	
	"sender of this message is the old receiver"
	sender := ProxyHandler receiverProxy. 
	senderHandler := ProxyHandler receiverProxyHandler.
	
	"****rebind the outer context of the closure. See issue 0". 
	receiver := self selfProxy.
	receiverHandler := self selfProxyHandler . 
	ProxyHandler receiverProxy:  receiver handler: receiverHandler.. 

	message := Message selector: selector  arguments: arguments .
	
	"Invoke 
	(1) param out on the sender, (2) param in on the receiver, 
	(3) delegate processing of the message
	(4) return out on the receiver, (5) return in on the sender "
		
	[ 
		target isAmopProxy ifTrue: [
			^ "senderHandler messageOut: message receiver: receiverHandler continue: [ :argsOut |"
				receiverHandler messageIn: message sender: senderHandler continue: [ :argsIn |
					self transformOutRet: (target chainFrom: receiverHandler  trap: block selector: selector arguments: ( self transformInArgs: argsIn) ) ]
				"]" .
		] ifFalse: [
			^ "senderHandler messageOut: message receiver: receiverHandler continue: [ :argsOut |"
				receiverHandler messageIn: message sender: senderHandler continue: [ :argsIn |
					| targetWithArgs |
					targetWithArgs := OrderedCollection new.
					targetWithArgs add: target. 
					targetWithArgs addAll: (self transformInArgs: argsIn ) . 
					self transformOutRet: ( block valueWithArguments: targetWithArgs ) ]
				" ]" .
		]
	] ensure: [
		ProxyHandler receiverProxy:  sender handler: senderHandler.. 
	]
	

	! !

ValueProxy subclass: #NilProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core'!

!NilProxy methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 13:41'!
chainFrom: previousHandler trap: block selector: selector  arguments: arguments
	
	| sender receiver senderHandler receiverHandler target message |
	
	
	target := handler target.  
	Transcript show:  self class asString ; show: '[' ; show:  self handler class asString ;
		 show: '@'; show: target class asString ; show: ']>>chainTrap ' ; show: selector ; cr.
	
	( selector beginsWith: 'equals' ) ifFalse: [ Error signal:  'support only equality check of nil' ]. 
	
	^ self transformOutRet: (  nil = arguments first baseObject ).! !

!NilProxy methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 13:42'!
trap: block selector: selector arguments: arguments
	
	| sender receiver senderHandler receiverHandler target message |
	
	target := handler target.  
	Transcript show:  self class asString ; show: '[' ; show:  self handler class asString ;
		 show: '@'; show: target class asString ; show: ']>>trap ' ; show: selector ; cr.
	
	( selector beginsWith: 'equals' ) ifFalse: [ Error signal:  'support only equality check of nil' ]. 
	
	^ self transformOutRet: (  nil = arguments first baseObject ).! !

!ValueProxy class methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 13:22'!
resolve: v
	( v isKindOf: BlockClosure ) ifTrue: [
		^ ClosureProxy for: v 
					selfProxy: ProxyHandler receiverProxy 
					selfProxyHandler: ProxyHandler receiverProxyHandler  .
	] .
	( v isKindOf: Boolean ) ifTrue: [
		^ BooleanProxy for: v .
	] .
	( v isKindOf: UndefinedObject ) ifTrue: [
		^ NilProxy for: v .
	] .
	^ ValueProxy for: v.! !

!ValueProxy methodsFor: 'as yet unclassified' stamp: 'ewe 1/31/2013 13:26'!
isValueProxy 
	^true! !

!ValueProxy methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 15:41'!
literalTrap: argument
		argument inspect. . self error: 'Not for value: literalTrap'.! !

!ValueProxy methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 15:40'!
newTrap: argument
	self error: 'Not for value: newTrap'.! !

!ValueProxy methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 15:40'!
readField: field 
	self error: 'Not for value: readField'.! !

!ValueProxy methodsFor: 'as yet unclassified' stamp: 'ewe 1/31/2013 11:50'!
transformInArgs: args
	^ (args collect: [ :item | item baseObject ]). ! !

!ValueProxy methodsFor: 'as yet unclassified' stamp: 'ewe 1/31/2013 11:48'!
transformOutRet: retVal
	^super literalTrap: retVal ! !

!ValueProxy methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 15:41'!
writeField: field value: value
	self error: 'Not for value: writeField.' . ! !

MetaObject subclass: #ProxyHandler
	instanceVariableNames: 'target'
	classVariableNames: 'Receiver ReceiverHandler'
	poolDictionaries: ''
	category: 'Amop-Core'!

ProxyHandler subclass: #MembraneHandler
	instanceVariableNames: 'membrane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Tests'!

!MembraneHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 12:03'!
failIfRevoked
	(self isRevoked )ifTrue: [ RevokedMembraneError signal: 'Membrane was revoked'].! !

!MembraneHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/12/2012 15:43'!
isRevoked
	^ membrane isRevoked. ! !

!MembraneHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/12/2012 15:52'!
membrane
	 ^membrane.! !

!MembraneHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/12/2012 15:52'!
membrane: aMembrane
	membrane := aMembrane.! !

!MembraneHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/12/2012 16:03'!
messageIn: aMessage sender: senderHandler continue: proceed
	| inArgs  |
	self failIfRevoked.
	inArgs := aMessage arguments collect: [ :arg |  membrane proxyFor: arg  ].	
	^ membrane proxyFor: ( proceed value: inArgs )! !

!MembraneHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/12/2012 16:05'!
revoke
	target := nil. ! !

!ProxyHandler class methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2012 14:16'!
receiverProxy
	^Receiver ! !

!ProxyHandler class methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2012 17:22'!
receiverProxy: anObject 
	^ Receiver := anObject.! !

!ProxyHandler class methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2012 11:21'!
receiverProxy: anObject handler: aHandler
	 Receiver := anObject.
	  ReceiverHandler:=aHandler.! !

!ProxyHandler class methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2012 11:20'!
receiverProxyHandler
	^ReceiverHandler! !

!ProxyHandler class methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2012 11:47'!
target: aTarget
	^ self new target: aTarget ; yourself. ! !

!ProxyHandler methodsFor: 'trap' stamp: 'ewe 2/7/2013 17:16'!
literalTrapContinue: proceed 
	| v |
	v:= proceed value. 
	( v isAmopProxy and: [ v isValueProxy ]  ) ifTrue: [
		^ v. 
	].
	^ ValueProxy resolve: v. ! !

!ProxyHandler methodsFor: 'trap' stamp: 'ewe 9/3/2012 15:05'!
messageIn: aMessage sender: senderHandler continue: proceed
	^ proceed value: aMessage arguments.! !

!ProxyHandler methodsFor: 'trap' stamp: 'ewe 9/3/2012 15:05'!
messageOut: aMessage receiver: receiverHandler continue: proceed
	^ proceed value: aMessage arguments. ! !

!ProxyHandler methodsFor: 'trap' stamp: 'ewe 1/22/2013 16:33'!
newTrapContinue: proceed 
	^ proceed value.! !

!ProxyHandler methodsFor: 'trap' stamp: 'ewe 9/3/2012 16:24'!
readField: aField  continue: proceed
	^ proceed value.! !

!ProxyHandler methodsFor: 'accessor' stamp: 'ewe 8/31/2012 11:47'!
target
	^ target.! !

!ProxyHandler methodsFor: 'accessor' stamp: 'ewe 8/31/2012 11:47'!
target: aTarget
	target := aTarget.! !

!ProxyHandler methodsFor: 'trap' stamp: 'ewe 9/3/2012 15:06'!
writeField: aField value: aValue continue: proceed
	^ proceed value: aValue.! !

ProxyHandler subclass: #TransitiveChainingHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Tests'!

TransitiveChainingHandler subclass: #BaseTracingHandler
	instanceVariableNames: ''
	classVariableNames: 'Counter'
	poolDictionaries: ''
	category: 'Amop-Core-Tests'!

!BaseTracingHandler class methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2012 10:47'!
counter
	^ Counter ! !

!BaseTracingHandler class methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2012 10:34'!
reset
	Counter := 0.! !

!BaseTracingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2012 11:34'!
literalTrapContinue: proceed 
	^super literalTrapContinue: proceed. ! !

!BaseTracingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2012 12:03'!
messageIn: aMessage sender: senderHandler continue: proceed
	( self shouldTrace: aMessage sender: senderHandler ) ifTrue: [
		Transcript show: '>>>>>' ; show: aMessage selector; cr. 
		Counter := Counter + 1. 
	].
	^ super messageIn: aMessage sender:  senderHandler continue: proceed.! !

!BaseTracingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2012 11:34'!
newTrapContinue: proceed 
	^ super newTrapContinue: proceed. ! !

!BaseTracingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2012 11:33'!
readField: aField  continue: proceed
	^super readField: aField continue: proceed.! !

!BaseTracingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2012 12:03'!
shouldTrace: aMessage sender: senderHandler
	self subclassResponsibility ! !

!BaseTracingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2012 11:33'!
writeField: aField value: proxy continue: proceed
	super writeField: aField value: proxy continue: proceed. ! !

BaseTracingHandler subclass: #TracingHandlerNoSelfSend
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Tests'!

!TracingHandlerNoSelfSend methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2012 12:05'!
shouldTrace: aMessage sender: senderHandler
	^ ( ProxyHandler receiverProxyHandler = senderHandler ) not ! !

BaseTracingHandler subclass: #TracingHandlerSelfSend
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Tests'!

!TracingHandlerSelfSend methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2012 12:04'!
shouldTrace: aMessage sender: senderHandler
	^true! !

TransitiveChainingHandler subclass: #ReadOnlyChainingHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Tests'!

!ReadOnlyChainingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2012 11:35'!
literalTrapContinue: proceed 
	^super literalTrapContinue: proceed.! !

!ReadOnlyChainingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2012 11:35'!
newTrapContinue: proceed 
	^super newTrapContinue: proceed.! !

!ReadOnlyChainingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2012 11:35'!
readField: aField  continue: proceed
	^super readField: aField continue: proceed.! !

!ReadOnlyChainingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 09:33'!
writeField: aField value: aValue continue: proceed
	ReadOnlyError signal:  'Read only handler can not write'. ! !

!TransitiveChainingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 1/31/2013 11:59'!
literalTrapContinue: proceed 
	"Will wrap the proceed in a ValueProxy"
	^self wrap: ( super literalTrapContinue: proceed ) .! !

!TransitiveChainingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2012 15:29'!
messageIn: aMessage sender: senderHandler continue: proceed
	| newArgs |
	newArgs := aMessage arguments collect: [ :arg | self wrap: arg  ] .
	^ proceed value: newArgs. ! !

!TransitiveChainingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 1/30/2013 12:06'!
newTrapContinue: proceed 
	^self wrap:  proceed value ! !

!TransitiveChainingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 1/30/2013 12:03'!
readField: aField  continue: proceed
	| roproxy proxy |
	proxy := proceed value.  
	Transcript show: 'xxxx Read '; show: aField ; show: ' '; show: proxy class asString ; cr.
	^self wrap: proxy! !

!TransitiveChainingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 1/30/2013 12:01'!
unwarp: proxy 
	"TODO check that proxy is of type self class"
	self flag: 'Why do we not wrap object of same class ' .
	( proxy isAmopProxy ) ifTrue: [
		Transcript show: 'Unwrap proxy'; cr. 
		^ proxy target. 
	].
	Transcript show: 'Unwrap noop'; cr. 
	^ proxy. ! !

!TransitiveChainingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 2/6/2013 17:08'!
wrap: arg 
	self flag: 'Wrapping object of the same kind is bypassed,. We should wrap only the first time an reference frows in a dynamic scope. See issue 6 ' .
	( arg  isAmopProxy ) ifTrue: [
		 arg handlers detect: [ :h | h isKindOf: self class ] ifNone: [ 
			Transcript show: 'Wrap proxy'; cr. 
			^ Proxy for: arg  handlerClass: self class .
		].
		Transcript show: 'Wrap bypass ' ; cr. 
		^ arg. 
	].
	Transcript show: 'Wrap proxy'; cr. 
	^ Proxy for: arg  handlerClass: self class .
! !

!TransitiveChainingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2012 15:28'!
writeField: aField value: proxy continue: proceed
	Transcript show: 'Write '; show: aField ; show: ' '; show: proxy class asString ; cr.
	^ proceed value: (self unwrap: proxy ).  ! !

!Object methodsFor: '*amop' stamp: 'ewe 9/5/2012 10:36'!
isAmopProxy
	^false! !

Object subclass: #OwnedObject3
	uses: TOwnershipCheck
	instanceVariableNames: 'dynamicOwner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Compiler'!

OwnedObject3 class
	uses: TOwnershipCheck classTrait
	instanceVariableNames: ''!

!OwnedObject3 methodsFor: 'transfer' stamp: 'ewe 5/2/2012 16:45'!
borrow: anObject do: aBlock
	| oldOwner |
	oldOwner := anObject owner. 
	anObject owner: self. 
	[
	  ^aBlock value: anObject. 
	] ensure: [
		anObject owner: oldOwner. 
	]! !

!OwnedObject3 methodsFor: 'testing' stamp: 'ewe 4/20/2012 11:20'!
canNotSend: selector to: receiver
	[ self canSend: selector to: receiver ] on: MessageFiltered do: [ ^ true ]. 
	^ false. 
	
! !

!OwnedObject3 methodsFor: 'testing' stamp: 'ewe 4/19/2012 16:10'!
canSend: selector to: receiver
	"Tests whether the object can send the message to the receiver"
	self checkValidSend3: receiver message: selector block: [:t | ^ true] arguments: {}.
	^ false. 
	
! !

!OwnedObject3 methodsFor: 'transfer' stamp: 'ewe 6/25/2012 15:01'!
copy
	<meta>
	| copy |
	copy := super copy. 
	copy ownerNoCheck: self owner. 
	^ copy. ! !

!OwnedObject3 methodsFor: 'enforcement' stamp: 'ewe 7/5/2012 15:32'!
isAccessibleFrom: aSource
	| interfaces |
	interfaces := self class allPragmas .
	self handleFilters: aSource selector: #any interfaces: interfaces. 
	
! !

!OwnedObject3 methodsFor: 'enforcement' stamp: 'ewe 7/5/2012 15:52'!
isAccessibleFromAllReferencs

	"This check is too slow in practice"
	true ifTrue: [ ^self ].
	
	self pointersTo do: [ :source | 
		( source isKindOf: OwnedObject3 ) ifTrue: [
			"Transcript show: 'Check from' ; show: source class asString ; cr.  "	
			self isAccessibleFrom: source ]
	]! !

!OwnedObject3 methodsFor: 'enforcement' stamp: 'ewe 6/27/2012 17:26'!
owner
	dynamicOwner isNil ifTrue: [ dynamicOwner := WorldOwner getInstance ].
	^ dynamicOwner. ! !

!OwnedObject3 methodsFor: 'transfer' stamp: 'ewe 7/5/2012 15:30'!
owner: newOwner
	"Transcript show:  'Attempt to transfer ownership (object: ' ; show: self class printString ;
	show: ', candidate owner: ' ; show:  newOwner class printString ; show:  ')' ; cr ."
	(newOwner acceptOwnershipOf: self ) ifTrue: [
		WorldOwner resetPathCache.
		dynamicOwner := newOwner. 
		"Transcript show:  'Ownership transfer succeeded' ; cr ."
		self isAccessibleFromAllReferencs.
		
	] ifFalse: [ 
		Transcript show: thisContext traceString  ; cr. 
		TransferError signal
	 ].
	"TODO the method does not return itself, as this might create violations"
	 ^nil. ! !

!OwnedObject3 methodsFor: 'enforcement' stamp: 'pmaer 7/4/2012 15:20'!
ownerNoCheck: newOwner
	"TODO this one should ideally never be used. Momentary necessary because of instrumented / not instrumente d code"
	"setter for owner"
	WorldOwner resetPathCache.
	dynamicOwner := newOwner.! !

Object subclass: #XBase
	instanceVariableNames: 'v'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core'!

XBase subclass: #XArray
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core'!

!XBase class methodsFor: 'as yet unclassified' stamp: 'ewe 2/7/2013 16:36'!
v: value
	^ super new v: value ; yourself. ! !

!XBase methodsFor: 'accessing' stamp: 'ewe 2/7/2013 16:37'!
= other
	^  other baseObject = v! !

!XBase methodsFor: 'accessing' stamp: 'ewe 2/7/2013 16:32'!
v
	^ v! !

!XBase methodsFor: 'accessing' stamp: 'ewe 2/7/2013 16:32'!
v: anObject
	v := anObject! !

XBase subclass: #XBoolean
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core'!

!XBoolean methodsFor: 'accessing' stamp: 'ewe 2/7/2013 16:39'!
ifFalse: aClosure  
	^ v ifFalse: aClosure! !

!XBoolean methodsFor: 'accessing' stamp: 'ewe 2/7/2013 16:39'!
ifTrue: aClosure 
	^ v ifTrue: aClosure! !

XBase subclass: #XClosure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core'!

XBase subclass: #XSmallInteger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core'!

!XSmallInteger methodsFor: 'as yet unclassified' stamp: 'ewe 2/7/2013 16:38'!
+ other
	 ^ XSmallInteger v:  v + other baseObject. ! !

Object subclass: #XUndefinedObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core'!

!XUndefinedObject methodsFor: 'as yet unclassified' stamp: 'ewe 2/7/2013 16:33'!
= other
	^  other baseObject = nil ! !
